static char *REGIONS_H="\n#include <stdio.h>\n#include <unistd.h>\n#include <math.h>\n#include <string.h>\n#include <sys/types.h>\n#ifdef __STDC__\n#include <stdlib.h>\n#include <stdarg.h>\n#else\n#include <varargs.h>\n#endif\n\n#define MASKINC 	10000\n#ifndef M_PI\n#define M_PI		3.14159265358979323846\n#endif\n#define SMALL_NUMBER	1.0E-24\n#define LARGE_NUMBER	65535\n#define PSTOP		-142857.142857\n\n#ifndef SZ_LINE\n#define SZ_LINE 	4096\n#endif\n#ifndef min\n#define min(x,y)	(((x)<(y))?(x):(y))\n#endif\n#ifndef max\n#define max(x,y)	(((x)>(y))?(x):(y))\n#endif\n#ifndef abs\n#define abs(x)		((x)<0?(-x):(x))\n#endif\n#ifndef feq\n#define feq(x,y)	(fabs((double)x-(double)y)<=(double)1.0E-15)\n#endif\n#ifndef NULL\n#define NULL 		(void *)0\n#endif\n\n#ifndef TOK_EREG\n#define TOK_EREG	1\n#endif\n#ifndef TOK_NREG\n#define TOK_NREG	2\n#endif\n#ifndef TOK_IREG\n#define TOK_IREG	4\n#endif\n\n#define PIXCEN(a)	(double)(a)\n#define PIXNUM(a)	(int)((a)+0.5) \n#define PIXSTART(a)	((int)(a)+1)\n#define PIXSTOP(a)	(((int)(a))==(a)?((int)(a)-1):((int)(a)))\n\n\n\n#define PIXINCL(a)	(int)((a)+1.0) \n\n\n#define EVFIELDONLY \"(evfield(g,1,1,1,(double)x,(double)y))\"\n\n#define XSNO 3\n\n\n#ifndef __filter_h\ntypedef struct filtmaskrec {\n  int region;\n  int y;\n  int xstart, xstop;\n} *FilterMask, FilterMaskRec;\n\n\ntypedef struct scanrec{\n  struct scanrec *next;\n  int x;\n} *Scan, ScanRec;\n\ntypedef struct shaperec {\n  int init;\n  double ystart, ystop;\n  Scan *scanlist;\n  \n  int nv;\n  double *xv;\n  \n  double r1sq, r2sq;\n  \n  double angl, sinangl, cosangl;\n  double cossq, sinsq;\n  double xradsq, yradsq;\n  double a;\n  \n  int npt;\n  double *pts;\n  \n  int xonly;\n  double x1, x2, y1;\n  double invslope;\n} *Shape, ShapeRec;\n\n\ntypedef struct gfiltrec {\n  int nshapes;			\n  int maxshapes;		\n  Shape shapes;			\n  int rid;			\n  int usebinsiz;		\n  char *evsect;			\n  double tlminx, tlminy;	\n  double binsizx, binsizy;	\n  double tloff;		        \n  int xmin, xmax, ymin, ymax;	\n  int block;			\n  int x0, x1, y0, y1;		\n  int *ybuf;			\n  int *x0s;			\n  int *x1s;			\n  int nmask;			\n  int maskdim;			\n  FilterMask masks;		\n} *GFilt, GFiltRec;\n#endif\n\n\nvoid imannulusi(GFilt g, int rno, int sno, int flag, int type, \n		double x, double y,\n		double xcen, double ycen, double iradius, double oradius);\nvoid imboxi(GFilt g, int rno, int sno, int flag, int type,\n	    double x, double y,\n	    double xcen, double ycen, double xwidth, double yheight,\n	    double angle);\nvoid imcirclei(GFilt g, int rno, int sno, int flag, int type,\n	       double x, double y,\n	       double xcen, double ycen, double radius);\nvoid imellipsei(GFilt g, int rno, int sno, int flag, int type,\n		double x, double y,\n		double xcen, double ycen, double xrad, double yrad,\n		double angle);\nvoid imfieldi(GFilt g, int rno, int sno, int flag, int type,\n	      double x, double y);\nvoid imlinei(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y,\n	     double x0, double y0, double x1, double y1);\nvoid impiei(GFilt g, int rno, int sno, int flag,  int type,\n	    double x, double y,\n	    double xcen, double ycen, double angle1, double angle2);\nvoid imqtpiei(GFilt g, int rno, int sno, int flag,  int type,\n	      double x, double y,\n	      double xcen, double ycen, double angle1, double angle2);\nvoid impointi(GFilt g, int rno, int sno, int flag, int type,\n	      double x, double y,\n	      double xcen, double ycen);\nvoid impandai(GFilt g, int rno, int sno, int flag, int type,\n	      double x, double y,\n	      double xcen, double ycen,\n	      double anglo, double anghi, double angn,\n	      double radlo, double radhi, double radn);\nvoid imnannulusi(GFilt g, int rno, int sno, int flag, int type,\n		 double x, double y,\n		 double xcen, double ycen,\n		 double lo, double hi, int n);\nvoid imnboxi(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y,\n	     double xcen, double ycen,\n	     double lox, double loy, double hix, double hiy, int n,\n	     double angle);\nvoid imnellipsei(GFilt g, int rno, int sno, int flag, int type,\n		 double x, double y,\n		 double xcen, double ycen,\n		 double lox, double loy, double hix, double hiy, int n,\n		 double angle);\nvoid imnpiei(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y,\n	     double xcen, double ycen,\n	     double lo, double hi, int n);\n\n#ifdef __STDC__\nvoid impolygoni(GFilt g, int rno, int sno, int flag, int type,\n		double x, double y, ...);\nvoid imvannulusi(GFilt g, int rno, int sno, int flag, int type,\n		 double x, double y, double xcen, double ycen, ...);\nvoid imvboxi(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y, double xcen, double ycen, ...);\nvoid imvellipsei(GFilt g, int rno, int sno, int flag, int type,\n		 double x, double y, double xcen, double ycen, ...);\nvoid imvpiei(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y, double xcen, double ycen, ...);\nvoid imvpointi(GFilt g, int rno, int sno, int flag, int type, \n	       double x, double y, ...);\n#endif\n\n\n\nint imannulus(GFilt g, int rno, int sno, int flag, int type,\n	      double x, double y,\n	      double xcen, double ycen, double iradius, double oradius);\nint imbox(GFilt g, int rno, int sno, int flag, int type,\n	  double x, double y,\n	  double xcen, double ycen, double xwidth, double yheight,\n	  double angle);\nint imcircle(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y,\n	     double xcen, double ycen, double radius);\nint imellipse(GFilt g, int rno, int sno, int flag, int type,\n	      double x, double y,\n	      double xcen, double ycen, double xrad, double yrad,\n	      double angle);\nint imfield(GFilt g, int rno, int sno, int flag, int type,\n	    double x, double y);\nint imline(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y,\n	   double x1, double y1, double x2, double y2);\nint impie(GFilt g, int rno, int sno, int flag, int type,\n	  double x, double y,\n	  double xcen, double ycen, double angle1, double angle2);\nint imqtpie(GFilt g, int rno, int sno, int flag, int type,\n	    double x, double y,\n	    double xcen, double ycen, double angle1, double angle2);\nint impoint(GFilt g, int rno, int sno, int flag, int type,\n	    double x, double y,\n	    double xcen, double ycen);\nint impanda(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y,\n	     double xcen, double ycen,\n	     double anglo, double anghi, double angn,\n	     double radlo, double radhi, double radn);\nint imnannulus(GFilt g, int rno, int sno, int flag, int type,\n	       double x, double y,\n	       double xcen, double ycen,\n	       double lo, double hi, int n);\nint imnbox(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y,\n	   double xcen, double ycen,\n	   double lox, double loy, double hix, double hiy, int n,\n	   double angle);\nint imnellipse(GFilt g, int rno, int sno, int flag, int type,\n	       double x, double y,\n	       double xcen, double ycen,\n	       double lox, double loy, double hix, double hiy, int n,\n	       double angle);\nint imnpie(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y,\n	   double xcen, double ycen,\n	   double lo, double hi, int n);\n#ifdef __STDC__\nint impolygon(GFilt g, int rno, int sno, int flag, int type,\n	      double x, double y, ...);\nint imvannulus(GFilt g, int rno, int sno, int flag, int type,\n	       double x, double y, double xcen, double ycen, ...);\nint imvbox(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y, double xcen, double ycen, ...);\nint imvellipse(GFilt g, int rno, int sno, int flag, int type,\n	       double x, double y, double xcen, double ycen, ...);\nint imvpie(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y, double xcen, double ycen, ...);\nint imvpoint(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y, ...);\n#endif\n\n\nint evannulus(GFilt g, int rno, int sno, int flag, int type,\n	      double x, double y,\n	      double xcen, double ycen, double iradius, double oradius);\nint evbox(GFilt g, int rno, int sno, int flag, int type,\n	  double x, double y,\n	  double xcen, double ycen, double xwidth, double yheight,\n	  double angle);\nint evcircle(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y,\n	     double xcen, double ycen, double radius);\nint evellipse(GFilt g, int rno, int sno, int flag, int type,\n	      double x, double y,\n	      double xcen, double ycen, double xrad, double yrad,\n	      double angle);\nint evfield(GFilt g, int rno, int sno, int flag, int type,\n	    double x, double y);\nint evline(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y,\n	   double x1, double y1, double x2, double y2);\nint evpie(GFilt g, int rno, int sno, int flag, int type,\n	  double x, double y,\n	  double xcen, double ycen, double angle1, double angle2);\nint evqtpie(GFilt g, int rno, int sno, int flag, int type,\n	    double x, double y,\n	    double xcen, double ycen, double angle1, double angle2);\nint evpoint(GFilt g, int rno, int sno, int flag, int type,\n	    double x, double y,\n	    double xcen, double ycen);\nint evnannulus(GFilt g, int rno, int sno, int flag, int type,\n	       double x, double y,\n	       double xcen, double ycen,\n	       double lo, double hi, int n);\nint evnbox(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y,\n	   double xcen, double ycen,\n	   double lox, double loy, double hix, double hiy, int n,\n	   double angle);\nint evnellipse(GFilt g, int rno, int sno, int flag, int type,\n	       double x, double y,\n	       double xcen, double ycen,\n	       double lox, double loy, double hix, double hiy, int n,\n	       double angle);\nint evnpie(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y,\n	   double xcen, double ycen,\n	   double lo, double hi, int n);\nint evpanda(GFilt g, int rno, int sno, int flag, int type,\n	    double x, double y,\n	    double xcen, double ycen,\n	    double anglo, double anghi, double angn,\n	    double radlo, double radhi, double radn);\n#ifdef __STDC__\nint evpolygon(GFilt g, int rno, int sno, int flag, int type,\n	      double x, double y, ...);\nint evvannulus(GFilt g, int rno, int sno, int flag, int type,\n	       double x, double y, double xcen, double ycen, ...);\nint evvbox(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y, double xcen, double ycen, ...);\nint evvellipse(GFilt g, int rno, int sno, int flag, int type,\n	       double x, double y, double xcen, double ycen, ...);\nint evvpie(GFilt g, int rno, int sno, int flag, int type,\n	   double x, double y, double xcen, double ycen, ...);\nint evvpoint(GFilt g, int rno, int sno, int flag, int type,\n	     double x, double y, ...);\n#endif\n\n";
